--[[ 

Author: 		HoFFi (modding-welt.com)
Remarks:		


Description: 	script for XPower electric charging

Version: 		1.0.0.0

Changelog: 		2022-06-07 	- initial release


--------------------------------------------------------------------------------------------------


]]


xpower = {};

xpower.modDir = g_currentModDirectory;
xpower.currentModName = g_currentModName;

function xpower.prerequisitesPresent(specializations)
    return true; 
end;

-- function xpower.initSpecialization()

    -- local schema = Vehicle.xmlSchema
    -- schema:setXMLSpecializationType("xpower")

    -- schema:register(XMLValueType.BOOL, "vehicle.xpower#showInHud", "show data in F1 hud", true)
    -- schema:register(XMLValueType.NODE_INDEX, "vehicle.xpower#leftWheel", "leftWheel")
    -- schema:register(XMLValueType.NODE_INDEX, "vehicle.xpower#rightWheel", "rightWheel")
    -- schema:register(XMLValueType.STRING, "vehicle.xpower#anim", "Sprayer anim")
    -- schema:register(XMLValueType.FLOAT, "vehicle.xpower#batteryCapacityHours", "batteryCapacityHours", 0.25)
    -- schema:register(XMLValueType.INT, "vehicle.xpower#dieselFillUnitI", "dieselFillUnitI", 1)
	
	
    -- schema:setXMLSpecializationType()

    -- local schemaSavegame = Vehicle.xmlSchemaSavegame
-- end

function xpower.registerEventListeners(vehicleType)
	for _, spec in pairs({"onLoad", "onUpdate", "onDraw"}) do
		SpecializationUtil.registerEventListener(vehicleType, spec, xpower)
	end
end


function xpower:onLoad(savegame)
	self.xpower = {}
	self.xpower.fillUnitIndex = 1;
	self.xpower.textLoading = "...";
	self.xpower.textLoadingBar = "";
	self.xpower.fillLevel = {};
end;


function xpower:onUpdate(dt)
	if self.spec_turnOnVehicle ~= nil then
		if self:getIsTurnedOn() then	
			self:addFillUnitFillLevel(self:getOwnerFarmId(), self.xpower.fillUnitIndex, 0.1, FillType.HERBICIDE, ToolType.UNDEFINED, nil)
			self.xpower.textLoading = g_i18n:getText("xpLoading");
		else
			self.xpower.textLoading = "Idle";
		end
	end
	
	self.xpower.fillLevel = self:getFillUnitFillLevel(1);
	if self.xpower.fillLevel >= 0 and self.xpower.fillLevel < 1 then
		self.xpower.textLoadingBar = ""
	end
	if self.xpower.fillLevel > 1 and self.xpower.fillLevel < 2 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_1")
	end
	if self.xpower.fillLevel > 2 and self.xpower.fillLevel < 3 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_2")
	end
	if self.xpower.fillLevel > 3 and self.xpower.fillLevel < 4 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_3")
	end
	if self.xpower.fillLevel > 4 and self.xpower.fillLevel < 5 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_4")
	end
	if self.xpower.fillLevel > 5 and self.xpower.fillLevel < 6 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_5")
	end
	if self.xpower.fillLevel > 6 and self.xpower.fillLevel < 7 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_6")
	end
	if self.xpower.fillLevel > 7 and self.xpower.fillLevel < 8 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_7")
	end
	if self.xpower.fillLevel > 8 and self.xpower.fillLevel < 9 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_8")
	end
	if self.xpower.fillLevel > 9 and self.xpower.fillLevel < 10 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_9")
	end
	if self.xpower.fillLevel == 10 then
		self.xpower.textLoadingBar = g_i18n:getText("LoadingBar_10")
	end
	
	if self.xpower.fillLevel >= 0.01 and self.xpower.fillLevel < 0.02 then
		g_currentMission:showBlinkingWarning(g_i18n:getText("xpNoPower"), 3000)
	end
	
		
end;

function xpower:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if self.isClient then
		if isActiveForInputIgnoreSelection then
			g_currentMission:addExtraPrintText(self.xpower.textLoading .. " | Buffer: " .. self.xpower.textLoadingBar)
		end
	end
end